# -*- coding: iso-8859-15 -*-
"""
    Basic functionality of a controller component in the
    mvc model.
"""

__revision__ = "0.1"
__author__ = "Francisco Jess Jordano Jimnez <arcturus@ardeenelinfierno.com>"

class Controller(object):
    """
        Class controller
    """
    
    def __init__ (self, view = None, model = None, callback = None):
        """
            Default constructor, it sets the view, the model and the
            callbacks associated.
        """
        self.__view__ = view
        self.__model__ = model
        if callback is not None:
            #Connect callback and view, but first check the integrity of the op
            if self.__view__ is not None and self.__view__.__dict__.has_key("connect_callback"):
                #Ok, we can set the callback
                self.__view__.connect_callback(callback)
                self.__callback__ = callback
                
    def set_view(self, view):
        """
            Set view 
        """
        self.__view__ = view
        if self.__callback__ is not None:
            if self.__view__.__dict__.has_key("connect_callback"):
                self.__view__.connect_callback(self.__callback__)
                
    def set_model(self, model):
        """
            Set the model
        """
        self.__model__ = model
        
    def set_callback(self, cb):
        """
            Set callback
        """
        if self.__view__ is not None:
            self.__view__.connect_callback(cb)
            self.__callback__ = cb
            
    def show_view(self):
        """
            Shows the view component
        """
        if self.__view__ is not None:
            self.__view__.show()
            
    def hide_view(self):
        """
            Hides the view component
        """
        if self.__view__ is not None:
            self.__view.__hide()
            