# -*- coding: iso-8859-15 -*-
"""
    This module provides hook classes that handles events.
"""

__revision__ = "0.1"
__author__ = "Francisco Jess Jordano Jimnez <arcturus@ardeenelinfierno.com>"

    
    
class ProgressBarHook(object):
    """
        Hook for progress bar objects
    """
    
    def __init__(self, pg):
        """
            Constructor with progressbar
        """
        self.progress_bar = pg
        
    def callback(self, per, str_value):
        """
            Stablish percentage completed and status text
        """
        self.progress_bar.set_fraction(per)
        self.progress_bar.set_text(str_value)
            
            
class LabelHook(object):
    """
        Hook for labels objects
    """
    
    def __init__(self, lbl):
        """
            Constructo with label as param
        """
        self.label = lbl
        
    def callback(self, text):
        """
            Stablish the text of the label
        """
        self.label.set_text(text)
        
class ControllerHook(object):
    """
        Hook for a controller class
    """
    
    def __init__(self, ctrl, callback):
        """
            Constructor, we pass the controller and the name
            of the callback function in this controller
        """
        self.callback = ctrl.__getattribute__(callback)
        
    def callback(self, data):
        """
            Call the callback in the controller
        """
        self.callback(data)